diff --git a/gcc/omp-offload.c b/gcc/omp-offload.c
index 2743e90f79a3..392ca56b1f4f 100644
--- a/gcc/omp-offload.c
+++ b/gcc/omp-offload.c
@@ -1097,6 +1097,39 @@ oacc_parse_default_dims (const char *dims)
   targetm.goacc.validate_dims (NULL_TREE, oacc_min_dims, -2, 0);
 }

+/* Remove parallelism dimensions below LEVEL which are not set in USED
+   from DIMS and emit a warning pointing to the location of FN. */
+
+static void
+oacc_remove_unused_partitioning (tree fn, int *dims, int level, unsigned used)
+{
+
+  bool host_compiler = true;
+#ifdef ACCEL_COMPILER
+  host_compiler = false;
+#endif
+
+  static char const *const axes[] =
+      /* Must be kept in sync with GOMP_DIM enumeration.  */
+      { "gang", "worker", "vector" };
+
+  char removed_partitions[20] = "\0";
+  for (int ix = level >= 0 ? level : 0; ix != GOMP_DIM_MAX; ix++)
+    if (!(used & GOMP_DIM_MASK (ix)) && dims[ix] >= 0)
+      {
+        if (host_compiler)
+          {
+            strcat (removed_partitions, axes[ix]);
+            strcat (removed_partitions, " ");
+          }
+        dims[ix] = -1;
+      }
+  if (removed_partitions[0] != '\0')
+    warning_at (DECL_SOURCE_LOCATION (fn), OPT_Wopenacc_parallelism,
+                "removed %spartitioning from %<kernels%> region",
+                removed_partitions);
+}
+
 /* Validate and update the dimensions for offloaded FN.  ATTRS is the
    raw attribute.  DIMS is an array of dimensions, which is filled in.
    LEVEL is the partitioning level of a routine, or -1 for an offload
@@ -1117,6 +1150,7 @@ oacc_validate_dims (tree fn, tree attrs, int *dims, int level, unsigned used)
   for (ix = 0; ix != GOMP_DIM_MAX; ix++)
     {
       purpose[ix] = TREE_PURPOSE (pos);
+
       tree val = TREE_VALUE (pos);
       dims[ix] = val ? TREE_INT_CST_LOW (val) : -1;
       pos = TREE_CHAIN (pos);
@@ -1126,14 +1160,15 @@ oacc_validate_dims (tree fn, tree attrs, int *dims, int level, unsigned used)
 #ifdef ACCEL_COMPILER
   check = false;
 #endif
+
+  static char const *const axes[] =
+      /* Must be kept in sync with GOMP_DIM enumeration.  */
+      { "gang", "worker", "vector" };
+
   if (check
       && warn_openacc_parallelism
-      && !lookup_attribute ("oacc kernels", DECL_ATTRIBUTES (fn))
-      && !lookup_attribute ("oacc parallel_kernels_graphite", DECL_ATTRIBUTES (fn)))
+      && !lookup_attribute ("oacc kernels", DECL_ATTRIBUTES (fn)))
     {
-      static char const *const axes[] =
-      /* Must be kept in sync with GOMP_DIM enumeration.  */
-       { "gang", "worker", "vector" };
       for (ix = level >= 0 ? level : 0; ix != GOMP_DIM_MAX; ix++)
        if (dims[ix] < 0)
          ; /* Defaulting axis.  */
@@ -1144,14 +1179,20 @@ oacc_validate_dims (tree fn, tree attrs, int *dims, int level, unsigned used)
                      "region contains %s partitioned code but"
                      " is not %s partitioned", axes[ix], axes[ix]);
        else if (!(used & GOMP_DIM_MASK (ix)) && dims[ix] != 1)
+         {
          /* The dimension is explicitly partitioned to non-unity, but
             no use is made within the region.  */
          warning_at (DECL_SOURCE_LOCATION (fn), OPT_Wopenacc_parallelism,
                      "region is %s partitioned but"
                      " does not contain %s partitioned code",
                      axes[ix], axes[ix]);
+          }
     }

+  if (lookup_attribute ("oacc parallel_kernels_graphite",
+                         DECL_ATTRIBUTES (fn)))
+    oacc_remove_unused_partitioning  (fn, dims, level, used);
+
   bool changed = targetm.goacc.validate_dims (fn, dims, level, used);

   /* Default anything left to 1 or a partitioned default.  */
diff --git a/libgomp/testsuite/libgomp.oacc-c-c++-common/acc_prof-kernels-1.c b/libgomp/testsuite/libgomp.oacc-c-c++-common/acc_prof-kernels-1.c
index ad33f72e2fb6..65c83dce01c9 100644
--- a/libgomp/testsuite/libgomp.oacc-c-c++-common/acc_prof-kernels-1.c
+++ b/libgomp/testsuite/libgomp.oacc-c-c++-common/acc_prof-kernels-1.c
@@ -7,6 +7,8 @@

 #include <acc_prof.h>

+/* { dg-skip-if "'kernels' not analyzed by Graphite at -O0" { *-*-* } { "-O0" } { "" } } */
+/* { dg-additional-options "-Wopenacc-parallelism" } */

 /* Use explicit 'copyin' clauses, to work around "'firstprivate'
    optimizations", which will cause the value at the point of call to be used
@@ -95,12 +97,8 @@ static void cb_enqueue_launch_start (acc_prof_info *prof_info, acc_event_info *e
     assert (event_info->launch_event.num_workers >= 1);
   else
     {
-#ifdef __OPTIMIZE__
-      assert (event_info->launch_event.num_workers == num_workers);
-#else
-      /* See 'num_gangs' above.  */
-      assert (event_info->launch_event.num_workers == 1);
-#endif
+      /* Unused partitioning levels get removed from "kernels" region. */
+      assert (event_info->launch_event.num_workers == real_num_workers);
     }
   if (vector_length < 1)
     assert (event_info->launch_event.vector_length >= 1);
@@ -183,6 +181,7 @@ int main()
   STATE_OP (state, = 0);
   num_gangs = 30;
   num_workers = 3;
+  real_num_workers = 1;
   vector_length = 5;
   {
 #define N 100
@@ -192,6 +191,8 @@ int main()
     /* { dg-prune-output "using vector_length \\(32\\), ignoring 5" } */
     {
       for (int i = 0; i < N; ++i)
+      /* { dg-warning "region is worker partitioned but does not contain worker partitioned code" "" { target *-*-* } .-1 } */
+      /* { dg-warning "removed worker partitioning from 'kernels' region" "" { target *-*-* } .-2 } */
        x[i] = i * i;
     }
     if (acc_device_type == acc_device_host)
@@ -208,6 +209,9 @@ int main()
   STATE_OP (state, = 0);
   num_gangs = 22;
   num_workers = 5;
+  /* No worker loop and hence, in a kernels region, worker partitioning
+     should be removed. */
+  real_num_workers = 1;
   vector_length = 7;
   {
 #define N 100
@@ -217,6 +221,8 @@ int main()
     /* { dg-prune-output "using vector_length \\(32\\), ignoring runtime setting" } */
     {
       for (int i = 0; i < N; ++i)
+      /* { dg-warning "region is worker partitioned but does not contain worker partitioned code" "" { target *-*-* } .-1 } */
+      /* { dg-warning "removed worker partitioning from 'kernels' region" "" { target *-*-* } .-2 } */
        x[i] = i * i;
     }
     if (acc_device_type == acc_device_host)